#include <gtest/gtest.h>
#include <sstream>
#include "solution.hpp"

TEST(MyTree, createEmpty) {
    MyTree tree;
    ASSERT_EQ(tree.root,nullptr);
}

TEST(MyTree, tree1) {
    std::string s = "a";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}

TEST(MyTree, tree2) {
    std::string s = "ab@";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}

TEST(MyTree, tree3) {
    std::string s = "abc@@";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}

TEST(MyTree, tree4) {
    std::string s = "ab@c@";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}

TEST(MyTree, tree5) {
    std::string s = "ab@cd@@";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}

TEST(MyTree, tree6) {
    std::string s = "abc@@de@@";
    MyTree tree(s);
    ASSERT_NE(tree.root,nullptr);
    std::stringstream ss;
    ss << tree;
    ASSERT_TRUE(s == ss.str());
}


